## net.sf.saxon.pattern
Class KeyPattern

    java.lang.Object
      net.sf.saxon.pattern.Pattern
          net.sf.saxon.pattern.KeyPattern

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, Container, PatternFinder

    public final class KeyPattern

extends Pattern

A KeyPattern is a pattern of the form key(keyname, keyvalue)

See Also:
  Serialized Form

Constructor Summary
`KeyPattern(StructuredQName keyName, Expression key)` Constructor

Method Summary
`Pattern` `analyze(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the pattern.
`boolean` `equals(java.lang.Object other)` Determine whether this pattern is the same as another pattern
`int` `getDependencies()` Get the dependencies of the pattern.
`NodeTest` `getNodeTest()` Get a NodeTest that all the nodes matching this pattern must satisfy
`int` `hashCode()` Hashcode supporting equals()
`java.util.Iterator` `iterateSubExpressions()` Iterate over the subexpressions within this pattern
`boolean` `matches(NodeInfo e, XPathContext context)` Determine whether this Pattern matches the given Node.
`void` `promote(PromotionOffer offer)` Offer promotion for subexpressions within this pattern.

Methods inherited from class net.sf.saxon.pattern.Pattern
`allocateSlots, getColumnNumber, getDefaultPriority, getExecutable, getFingerprint, getHostLanguage, getLineNumber, getLocationProvider, getNodeKind, getPublicId, getSystemId, internalMatches, make, makeSearchExpression, replaceSubExpression, selectNodes, setExecutable, setLineNumber, setOriginalText, setSystemId, simplify, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### KeyPattern

    public KeyPattern(StructuredQName keyName,
                      Expression key)

  Constructor

  Parameters:
    `keyName` - the name of the key
    `key` - the value of the key: either a StringValue or a VariableReference

Method Detail

### analyze

    public Pattern analyze(ExpressionVisitor visitor,
                           ItemType contextItemType)
                    throws XPathException

  Type-check the pattern. This is needed for patterns that contain variable references or function calls.

  Overrides:
    `analyze` in class `Pattern`
  Parameters:
    `visitor` - the expression visitor
    `contextItemType` - the type of the context item, if known, at the point where the pattern is defined
  Returns:
    the optimised Pattern
  Throws:
    `XPathException`

### getDependencies

    public int getDependencies()

  Get the dependencies of the pattern. The only possible dependency for a pattern is on local variables. This is analyzed in those patterns where local variables may appear.

  Overrides:
    `getDependencies` in class `Pattern`
  Returns:
    the dependencies, as a bit-significant mask

### iterateSubExpressions

    public java.util.Iterator iterateSubExpressions()

  Iterate over the subexpressions within this pattern

  Overrides:
    `iterateSubExpressions` in class `Pattern`
  Returns:
    an iterator over the subexpressions. Default implementation returns an empty sequence

### promote

    public void promote(PromotionOffer offer)
                 throws XPathException

  Offer promotion for subexpressions within this pattern. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

  Unlike the corresponding method on `Expression`, this method does not return anything: it can make internal changes to the pattern, but cannot return a different pattern. Only certain kinds of promotion are applicable within a pattern: specifically, promotions affecting local variable references within the pattern.

  Overrides:
    `promote` in class `Pattern`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Throws:
    `XPathException` - if any error is detected

### matches

    public boolean matches(NodeInfo e,
                           XPathContext context)
                    throws XPathException

  Determine whether this Pattern matches the given Node.

  Specified by:
    `matches` in class `Pattern`
  Parameters:
    `e` - The NodeInfo representing the Element or other node to be tested against the Pattern
    `context` - The dynamic context. Only relevant if the pattern uses variables, or contains calls on functions such as document() or key().
  Returns:
    true if the node matches the Pattern, false otherwise
  Throws:
    `XPathException`

### getNodeTest

    public NodeTest getNodeTest()

  Get a NodeTest that all the nodes matching this pattern must satisfy

  Specified by:
    `getNodeTest` in class `Pattern`
  Returns:
    a NodeTest, as specific as possible, which all the matching nodes satisfy

### equals

    public boolean equals(java.lang.Object other)

  Determine whether this pattern is the same as another pattern

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `other` - the other object

### hashCode

    public int hashCode()

  Hashcode supporting equals()

  Overrides:
    `hashCode` in class `java.lang.Object`

Copyright (c) Saxonica Limited. All rights reserved.